package intro.decon;
import jam.vector.*;
import juice.solver.*;
import juice.operator.*;
import rsf.vector.*;
import conv.convi.*; 

/**
* I solve y = B x for x.                                        <BR>
* y is a    known time series                         (trace).  <BR>
* B is a    known convolution operator of the wavelet (wavlt).  <BR>
* x is an unknown relectivity                                   <BR>
* 
* This creates the normal equations: y_n = B' y and B_n = B'B and 
* call a CGSolver to solve y_n = B_n x, respectively B'b = B'B x. 
*
* <BR><!--#include file="./source.inc"--><BR> 
*/ 
public class IcaiDecon { 
  public static void main(String[] args) {
    Rsf yy = RsfFactory.newRsf("./trace.H");           // reads   y
    Rsf bb = RsfFactory.newRsf("./wavlt.H");           // reads   b 
    Icai convB = new IcaiFactory(bb).                  // creates B 
      getIcaiFromOutputSpace((RsfSpace) yy.getSpace()); 
    Vector     yn = convB.adjoint().image(yy);         // creates y_n = B'y 
    CompoundLinOpAdj                                   // creates B_n = B'B
      convBn = new CompoundLinOpAdj(convB, convB.adjoint());
    Rsf xx = (Rsf) convBn.getDomain().newMember();     // creates x 
    new CGSolver().solve(convBn,yn,xx);                // solves  y_n = B_n x
    xx.write( System.out );                            // writes  x 
  }
}
