package intro.decon;

import jam.operator.*;
import rsf.vector.*;
import sep.io.*;
import conv.convt.*;
import conv.convi.*;

/**
 * Creates a blurred time series from an original one g = h * f. 
 * returns the reflectivity and the blurred seismic trace. 
 * Should return wavelet. 
 * Needs cleanup. 
 * 
 * @param in=filename      reflectivity trace h (defaults to random series)
 * @param wavelet=filename blurring filter    g 
 * @param conv=internal    boundary type of convolution [internal,transient]
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class SynTrace { 
  public static void main( String[] args) { 
    ArgumentKeeper argKeeper = new ArgumentKeeper( args);
 
    Rsf wavelet = RsfFactory.newRsf(argKeeper.getString("wavelet"));
    Rsf reflectivity; 
    if (argKeeper.containsKey("in")) {
      reflectivity = RsfFactory.newRsf(argKeeper.getString("in")); 
    }
    else {
      Axis[] ax = {(Axis) ((RsfSpace) wavelet.getSpace()).getAxes()[0].copy()};
      ax[0].nsamples = argKeeper.getInt("n1","250"); 
      reflectivity   = RsfFactory.newRsf(ax);
      reflectivity.rand();
    }
    reflectivity.write("rflct.H"); 

    hasAdjoint myConv = new IcaiFactory(wavelet).
	getIcaiFromInputSpace((RsfSpace) reflectivity.getSpace());

    if (argKeeper.containsKey("conv")) {
      if (argKeeper.getString("conv").equals("transient")) { 
	myConv = new TcaiFactory(wavelet).
	  getTcaiFromInputSpace((RsfSpace) reflectivity.getSpace());
      }
    }
    Rsf seisTrace = (Rsf) myConv.image(reflectivity); 
    seisTrace.write(System.out);
  }
}

