package isf.vector;

import  jam.JamObject;
import java.util.Vector;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * @see       Isf
 * @author    Matthias Schwab
 */
public class KeysV implements Keys { 
  Vector keys; 

  //constructors 
  public KeysV(int   n) {
    this.keys = new Vector(n);
    for( int i = 0; i < n; i++) 
      this.keys.addElement(new Key("distance", "km"));
  }    
  public KeysV(Key[] keys) {
    int nkeys  = keys.length;
    this.keys  = new Vector(nkeys);
    for( int i = 0; i < nkeys; i++) 
      this.keys.addElement(keys[i]);
  }
  // maybe I should check that the vector elements are of type Key.
  public KeysV(Vector keys) { 
    this.keys = keys;
  }
  // copy constructor
  public KeysV(KeysV src) {
    int nkeys = src.getNumberOfKeys();
    this.keys = new Vector(nkeys);
    for (int k = 0; k < nkeys; k++) {
      this.keys.setElementAt(((Key)src.keys.elementAt(k)).copy(), k);
    }
  }
  public JamObject copy() { return new KeysV(this);}

  //comparitor
  public boolean equals(Object spc ) {
    if (  this == spc                              ) return true ;
    if (! (spc instanceof KeysV)                 ) return false;
    if (! juice.util.JuiceUtil.equalVectors(this.keys, 
			       ((KeysV)spc).keys)) return false;
    return true; 
  }

  // I/O
  public String toString() { 
    return juice.util.JuiceUtil.vectorToString("Key",keys,"\n");
  }

  //accessor 
  public int getNumberOfKeys() { return keys.size    (); }
  public int capacity       () { return keys.capacity(); }

  // vector - database accessor 
  public void         insertElementAt(Key newKey, int index) {
                 keys.insertElementAt(    newKey,     index);
  }
  public void         removeElementAt(            int index) {
                 keys.removeElementAt(                index);
  }
  public void            addElement  (Key newKey           ) {
                 keys.   addElement  (    newKey           );
  }
  public void            setElementAt(Key newKey, int index) {
                 keys.   setElementAt(    newKey,     index);
  }
  public    Key             elementAt(            int index) {
    return (Key) keys.      elementAt(                index);
  }  
}
