package isf.vector;

import jam.JamObject;
import jam.vector.Space;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * @see       Isf
 * @author    Matthias Schwab
 */
public class SpacesV implements Spaces { 
  java.util.Vector vec                  ; 
  Space            sgl                  ;
  boolean          hasSingleElementSpace;
  int              numberOfElements     ;
  //constructors 
  public SpacesV(Space[] spc) {
    hasSingleElementSpace = false;
    int dim = spc.length;
    vec     = new java.util.Vector(dim);   
    for( int i = 0; i < dim; i++ ) {
      vec.addElement(spc[i]); 
    }
  }
  public SpacesV(Space   spc, int elements) {
    hasSingleElementSpace = true;
    numberOfElements      = elements;
    sgl = spc;
  }

  // maybe I should check that the vector elements are of type Space.
  public SpacesV(java.util.Vector vec) { 
    /*
     * if ( ! (vec.elementAt(0) instanceOf Space) ) 
     *   System.err.println("***SpacesV: vec isn't a java Vector of Spaces");
     *
     */
    this.vec = vec;
  }
  // copy constructor
  public SpacesV(SpacesV src) {
    if (src.hasSingleElementSpace()) {
      hasSingleElementSpace = true                ;   
      numberOfElements      = src.numberOfElements;
      sgl                   = src.sgl             ; 
    }
    else {
      int elements = src.getNumberOfElements();
      vec = new java.util.Vector(elements);
      for (int k = 0; k < elements; k++) {
	vec.setElementAt(((Space)src.vec.elementAt(k)).copy(), k);
      }
    }
  }
  public JamObject copy() { return new SpacesV(this); }

  //comparitor
  public boolean equals(Object spc ) {
    if (  this == spc                             ) return true ;
    if (! (spc instanceof SpacesV)                ) return false;
    if (! (hasSingleElementSpace == ((SpacesV)spc).hasSingleElementSpace))
                                                    return false;
    if (hasSingleElementSpace) 
      if (! sgl.equals(((SpacesV)spc).sgl) ) return false;
    else
      if (! juice.util.JuiceUtil.equalVectors(this.vec, 
			       ((SpacesV)spc).vec)) return false;
    return true; 
  }

  //accessor 
  public boolean hasSingleElementSpace() { return hasSingleElementSpace; }
  public int getNumberOfElements      () { 
    return (hasSingleElementSpace ? numberOfElements : vec.size()); 
  }
  public int capacity                 () { 
    return (hasSingleElementSpace ? 1 : vec.capacity()); 
  }
  public Space getSpace(int i) { 
    if (hasSingleElementSpace) 
      return sgl;
    else 
      return (Space) vec.elementAt(i);
  }

  // vector - elembase accessor 
  public void     insertElementAt(Space newSpace, int index) {
    if   (hasSingleElementSpace) numberOfElements++;
    else      vec.insertElementAt(      newSpace,     index);
  }
  public void     removeElementAt(                int index) {
    if   (hasSingleElementSpace) numberOfElements--;
    else      vec.removeElementAt(                    index);
  }
  public void        addElement  (Space newSpace           ) {
    if   (hasSingleElementSpace) numberOfElements++;
    else        vec.addElement   (      newSpace           );
  }
  public void        setElementAt(Space newSpace, int index) {
    if   (hasSingleElementSpace) ; 
    else         vec.setElementAt(      newSpace,     index);
  }
  public Space          elementAt(                int index) {
    if   (hasSingleElementSpace) return sgl;
    else  return (Space)vec.elementAt(                index);
  }  

  // I/O
  public String toString() {
    if (hasSingleElementSpace) {
      StringBuffer buf = new StringBuffer();
      buf.append("Element Space : \n" + sgl + "\n");
      return buf.toString(); 
    }
    else {
      return juice.util.JuiceUtil.vectorToString("Space",vec,"\n");
    }
  }
}
