package net.www.content.application;

import java.net.*;
import java.io.*;

class OurContentHandlerFactory implements ContentHandlerFactory {

  public ContentHandler createContentHandler(String mimetype) {
    if (mimetype.equalsIgnoreCase("application/x-tar")) 
      return new net.www.content.application.x_tar();
    else
      return null;
  }
}

public class x_tarTest {
  public static void main (String[] args) throws Exception {

    URLConnection.setContentHandlerFactory(new OurContentHandlerFactory());
    URL url; 
    if (args.length == 1) {
      url = new URL(args[0]);
    }
    else {
      url = new URL(
	 "file:/homes/sep/matt/jag/net/www/content/application/x_tarTest.tar"
	 );
    }
    StringBuffer s = new StringBuffer((String)url.getContent());
    System.out.println(s);
    System.out.println(s.charAt(0));
    System.out.println(s.charAt(1));
    System.out.println(s.charAt(2));
    System.out.println(s.charAt(3));

    boolean passed = true; 
    if (s.charAt(0) != 'T') passed = false; 
    if (s.charAt(1) != 'a') passed = false; 
    if (s.charAt(2) != 'p') passed = false; 
    if (s.charAt(3) != 'e') passed = false; 
    if (passed) 
      System.out.println("passed");
    else 
      System.out.println("failed"); 
    
  }
}

