package rn.vector;

import    jam.vector.*;
import    jam.JamObject;

/**
 * <BR><!--#include file="./source.inc"-->
 *
 * @author Matthias Schwab
 */
public class RnSpc implements Space {
  int dim; 
  public RnSpc(int dim) { 
    this.dim = dim; 
  }
  RnSpc(RnSpc spc) { 
    dim = spc.dim; 
  }

  public RnSpc getSpace() {
    return this; 
  }

  private RnSpc() {}

  public Vector    newMember()         { return new RnVec(this); }
  public boolean   hasMember(Vector v) { return this.equals(v.getSpace()); }

  public JamObject copy() { 
    return new RnSpc(this); 
  }

  public int getNSamples() { return dim; } 

  public boolean equals(Object obj)  {
    if (this == obj)                     return true;
    if (! (obj instanceof RnSpc))        return false;
    if ( ((RnSpc) obj).dim != this.dim ) return false;
    return true; 
  }
  public String toString() {
    return new String("RnSpc with dimension: " + dim);
  }
}
