package rn.vector;

import   jam.vector.*;
import juice.util.JuiceUtil;
import juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */

public class RnVecTest extends juice.util.Tester {
  public static void main(String[] args) {
    System.out.println("RnVec TEST\n--------\n");
    boolean passed = true;
    
    float[] values = {-0.6987f, -0.91629f, -0.22314f, 0.47000f, 0.50515f};
    RnVec rnOrig = new RnVec(values);
    System.out.println("{-0.6987,-.9163,-.2231, .4700, .5051}: "+ rnOrig);
    for (int i=0; i < values.length; i++) {
      //if (rnOrig.d[i] != values[i]) passed = false; 
    }

    // test reading and writing
    // should use serializable!! 

    RnVec rnRand = new RnVec(rnOrig);
    rnRand.rand();
    System.out.println("random values: " + rnRand);

    RnVec rnZero = new RnVec((RnSpc) rnRand.getSpace());
    rnZero.zero();
    System.out.println("zero values: " + rnZero);
    for (int i=0; i<values.length; i++) {
      if (rnZero.d[i] != 0.0f) passed = false; 
    }
    RnVec rnFill = new RnVec((RnSpc) rnRand.getSpace());
    rnFill.fill(1);
    System.out.println("constant 1: " + rnFill);
    for (int i=0; i<values.length; i++) {
      if (rnFill.d[i] != 1.f) passed = false; 
    }
    rnFill.add(rnOrig); 
    for (int i=0; i<values.length; i++) {
      if (rnFill.d[i] != values[i] + 1.f) passed = false; 
    }
    rnFill.fill(3.f);
    rnFill.scale(2.5f);
    for (int i=0; i<values.length; i++) {
      if (rnFill.d[i] != 7.5f) passed = false; 
    }
    System.err.println("Norm should be: " + rnFill.norm());
    if (! JuiceUtil.approx(rnFill.norm(),16.77050983f)) passed = false;

    rnFill.zero();
    passed &= rnZero.equals(rnFill);

    Tester.exit(passed);
  }
}

