package  rsfF.util;

import   rsfF.vector.*;
import   juice.util.JuiceUtil;
import  java.io.DataInputStream;
import  java.io.IOException;
import   sep.io.*;

/**
 * Needs to be generalized to other dataTypes
 * <BR><!--#include file="./source.inc"--><BR>
 */

public class Attr {
  Rsf             rsfIput; 

  public Attr(Rsf iput) { rsfIput = iput; }

  public String toString() {
    float[] rsfData = rsfIput.getData();

    double mean  = 0.;
    double norm  = 0.;
    double nrm2  = 0.;
    double rms   = 0.;
    int num      = rsfData.length ;
    int numZ     = 0 ;
    int max      = 0 ;
    int min      = 0 ;
    double maxV  = rsfData[0];
    double minV  = rsfData[0];

    for (int i=0; i < num; i++) {
      mean += rsfData[i];
      nrm2 += rsfData[i] * rsfData[i];
      if (rsfData[i] != 0) numZ++;
      if (rsfData[i] > maxV) {
	maxV = rsfData[i];
	max  = i;
      }
      if (rsfData[i] < minV) {
	minV = rsfData[i];
	min  = i;
      }      
    }

    // create the results
    StringBuffer results = new StringBuffer(300);

    mean = mean / rsfData.length;
    rms  = nrm2;
    rms  = Math.sqrt(nrm2 / rsfData.length);
    norm = Math.sqrt(norm);

    int[] indices = new int[rsfIput.getDimension()];
    results.append("mean value = ").append(mean).append("\n");
    results.append("rms  value = ").append(rms).append("\n");
    results.append("norm value = ").append(norm).append("\n");
    results.append("maximum value = ").append(rsfData[max]).append(" at ");
    results.append(" at ").append(max).append(" (");
    results.append(JuiceUtil.arrayToString(rsfIput.getIndices(max), " "));
    results.append(" )").append("\n");
    results.append("minimum value = ").append(rsfData[min]).append(" at ");
    results.append(" at ").append(min).append(" (");
    results.append(JuiceUtil.arrayToString(rsfIput.getIndices(min), " "));
    results.append(" )").append("\n");

    results.append("number of nonzero samples = ").append(numZ).append("\n");
    results.append("number of samples = ").append(num);

    return results.toString();
  }

  /** 
   * Attr [--test --version --help -v] filename
   * Attr computes some statistics of a given SEP rsfData set.
   *    --test:       run some tests
   *    --version:    state the program version
   *    --help:       print this selfdoc
   */

  public static void main(String[] args) throws IOException {

    ArgumentKeeper command = new ArgumentKeeper(args);
    String[] fileNames = command.getNames();

    if (command.containsKey("--version")) {
      System.out.println("This should come from sepObject?");
      System.exit(0);
    }
    if (command.containsKey("--help")) {
      System.out.println("seoObject should print an extracted selfdoc?");
      System.exit(0);
    }
    Rsf myData        = new  Rsf(new DataInputStream(System.in));
    System.out.println(new Attr(myData));
  }
}

    


