package  rsfF.util;

import   sep.io.*;
import   rsf.vector.Axis;
import  rsfF.vector.*;
import  java.io.*;
import  java.util.*;

/**
 * Should this be an object with a main wrapper? 
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class Histogram {
  public static void main(String[] args) throws java.io.IOException {

    ArgumentKeeper command = new ArgumentKeeper(args);

    /*
     * this should really be documented in javadoc .. no more selfdoc .. 
     */ 
    if (command.containsKey("--help")) {
      System.out.println(
          "Histogram [--test --version --help] n1=10 < filename"   + "\n" + 
	  "computes a histogram of all input values"               + "\n" + 
	  "   n1=[10]        number of amplitude bins"             + "\n" + 
	  "   o1=[minOfData] smallest amplitude bin displayed"     + "\n" + 
	  "   d1=[(maxOfData -  minOfData)/n1] bin increment"      + "\n" + 
	  "   --help:       print this selfdoc"                    + "\n" +
	  " "                                                     
          );
      System.exit(0);
    }

    /* 
     * Find the output parameter n1,o1,d1 
     */
    int n1 = 10;
    if (command.containsKey("n1")) {
      n1 = command.getInt("n1");
    }

    DataInputStream   fin = new DataInputStream(System.in);
    Rsf             input = new Rsf(fin);

    float maxV  = input.d[0];
    float minV  = input.d[0];
    for(int i=0; i < input.getTotalNSamples(); i++) {
      if (input.d[i] > maxV) {
	maxV = input.d[i];
      }
      if (input.d[i] < minV) {
	minV = input.d[i];
      }      
    }
    float o1 = minV;
    if (command.containsKey("o1")) {
      o1 = command.getFloat("o1");
    }
    float d1 = (maxV - minV + 1) / n1; // there should be a check zero division
    if (command.containsKey("d1")) {
      d1 = command.getFloat("d1");
    }
    String label1 = "Amplitude";
    if (command.containsKey("label1")) {
      label1 = command.getString("label1");
    }
    String unit1 = "Give it a unit!";
    if (command.containsKey("unit1")) {
      unit1 = command.getString("unit1");
    }

    /* 
     * Create the output vector, sort the amplitudes
     */
    Axis axis = new Axis(n1,d1,o1,label1,unit1); 
    Axis axisArray[] = {axis};
    Rsf  bin  = new Rsf(axisArray);

    int index = 0; 
    d1 = 1/d1; 
    for(int i=0; i < input.getTotalNSamples(); i++) {
      index = (int)((input.d[i]-o1) * d1);
      if (index > -1 && index < n1) {
	bin.d[index] += 1F;
      }
    }

    /*
    for(int i=0; i < n1; i++) {
      System.out.println( i + " " + bin[i] );
    }
    */

    /* 
     * I would like to be able to set these values ...
    fData.set("label2","Number_of_Samples");
    fData.set("title","Histogram");
    */

    DataOutputStream fout = new DataOutputStream(System.out);
    bin.write(fout);
    fout.close();
  }
}
    
