package  rsfF.util;

import   sep.io.*;
import  java.util.*;
import  java.io.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class Mask {
  public static void main(String[] args) throws IOException {

    ArgumentKeeper command = new ArgumentKeeper(args);

    if (command.containsKey("--version")) {
      System.out.println("This has not been released yet");
      System.exit(0);
    }
    if (command.containsKey("--test")) {
      System.out.println("has not been implemented");
      System.exit(0);
    }
    if (command.containsKey("--help")) {
      System.out.println(
          "Mask [--test --version --help] amp= absamp= lap= < filename"+ "\n" +
	  "masks out input values depending on the given criteria"     + "\n" +
	  "   amp=0    if data amplitude is bigger than amp"           + "\n" +
	  "   absamp=0 if absolute amplitude is bigger than absamp"    + "\n" +
	  "   lap=0    if absolute laplacian is larger than lap"       + "\n" +
          "   --test:       run some tests"                        + "\n" + 
	  "   --version:    state the program version"             + "\n" + 
	  "   --help:       print this selfdoc"                    + "\n" +
	  " "                                                     
          );
      System.exit(0);
    }

    float amp = 0.F;
    if (command.containsKey("amp")) {
      amp = command.getInt("amp");
    }

    DataInputStream fin; 

    fin = new DataInputStream(new BufferedInputStream(System.in));

    RegularData myData = new RegularData();
    myData.read(fin);
    float[] data = (float[])myData.getData();

    for(int i=0; i < data.length; i++) {
      if (data[i] > amp) {
	  data[i] = 1.F ;
      }
      else {
	  data[i] = 0.F ;
      }      
    }

    myData.setData(data);
    myData.set("title","Histogram");

    DataOutputStream fout = new DataOutputStream(System.out);
    myData.write(fout);
    fout.close();
  }
}
    
