package  rsfF.util;

import   sep.io.*;
import  rsfF.vector.*;
import  java.io.*;
import  java.util.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class RandomSelector {
  public static void main(String[] args) throws IOException {

    ArgumentKeeper command = new ArgumentKeeper(args);

    /*
     * this should really be documented in javadoc .. no more selfdoc .. 
     * would be nice to be able to set a seed.
     */ 
    if (command.containsKey("--help")) {
      System.out.println(
	  "RandomSelector sample=10 < infile > outfile"            + "\n" + 
	  "selects random samples of a given SEP data set."        + "\n" + 
	  "   sample=10    number of samples selected"             + "\n" + 
	  "   --help:       print this selfdoc"                    + "\n" +
	  ""                                                       + "\n" +
          "see Rsf"
          );
      System.exit(0);
    }

    /* 
     * Get input data 
     */
    DataInputStream fin = new DataInputStream(System.in); 
    Rsf input           = new Rsf(fin);

    /*
     * How many samples do we choose randomly?
     */ 
    int sample = 10; 
    if (command.containsKey("sample")) {
      sample = command.getInt("sample");
    }

    /* 
     * Select random indices, set output data, write data to stdout 
     */
    Rsf ouput           = new Rsf(sample);
    Random hickup = new Random();
    for (int i=0; i < sample; i++) {
      ouput.d[i] = input.d[(int)(hickup.nextFloat() * input.getTotalNSamples())];
    }
    DataOutputStream fout = new DataOutputStream(System.out);
    ouput.write(fout);
    fout.close();
  }
}
 
    
      
